#include <piece.h>
#include <string.h>
#include "pshell.h"

// WCustrtok()ɂ̓oÔŒu
static char *pshellStrtok(char* s1, const char* s2){
  static char *ssave = "";
  char *sbegin, *send;

  sbegin = s1 ? s1 : ssave;
  sbegin += strspn(sbegin, s2);
  if(*sbegin == '\0'){
    ssave = "";
    return NULL;
  }

  send = sbegin + strcspn(sbegin, s2);
  if(*send != '\0') *send++ = '\0';
  ssave = send;
  return sbegin;
}

////////////////////////////////////////////////////////////////////////////////

// RtBOt@C̓ǂݍ
void readConfigFile(void){
  FILE_ENTRY *f, *currentFolder;
  FILEACC facc;
  char fileBuffer[SECTOR_SIZE + 1];
  char *line;
  int level;

  // RtBOt@CȂΉȂ
  if(pceFileOpen(&facc, CONFIG_FILE, FOMD_RD) == 1){
    return;
  }

  // t@Cǂݍ݁AŌ'\0't
  fileBuffer[pceFileReadSct(&facc, fileBuffer, 0, SECTOR_SIZE)] = '\0';
  pceFileClose(&facc);

  currentFolder = uncategorizedProgram;
  printSize = FALSE;
  printSectors = FALSE;

  // RtBOt@C1sǂ
  line = pshellStrtok(fileBuffer, "\r\n");
  while(line != NULL){

    // su\vȂR}hs
    if(*line == '\\'){
      line++;

      if(strcmp(line, "program") == 0){
        currentFolder = uncategorizedProgram;
      }
      else if(strcmp(line, "data") == 0){
        currentFolder = uncategorizedData;
      }
      else if(strcmp(line, "print_size") == 0){
        printSize = TRUE;
        printSectors = FALSE;
      }
      else if(strcmp(line, "print_sectors") == 0){
        printSize = FALSE;
        printSectors = TRUE;
      }
      else if(strcmp(line, "no_print_voltage") == 0){
        pcePowerSetReport(PWR_RPTOFF);
      }
      else if(strcmp(line, "sort_by_name") == 0){
        sortMode = NAME;
        sortFiles();
      }
      else if(strcmp(line, "sort_by_name_reverse") == 0){
        sortMode = NAME_REVERSE;
        sortFiles();
      }
      else if(strcmp(line, "sort_by_type") == 0){
        sortMode = TYPE;
        sortFiles();
      }
      else if(strcmp(line, "sort_by_type_reverse") == 0){
        sortMode = TYPE_REVERSE;
        sortFiles();
      }
      else if(strcmp(line, "sort_by_caption") == 0){
        sortMode = CAPTION;
        sortFiles();
      }
      else if(strcmp(line, "sort_by_caption_reverse") == 0){
        sortMode = CAPTION_REVERSE;
        sortFiles();
      }
      else if(strcmp(line, "sort_by_size") == 0){
        sortMode = SIZE;
        sortFiles();
      }
      else if(strcmp(line, "sort_by_size_reverse") == 0){
        sortMode = SIZE_REVERSE;
        sortFiles();
      }
    }

    // s^uȂtH_c[ւ̓o^
    else if(*line == '\t'){
      level = 1;
      while(*line == '\t'){
        level++;
        line++;
      }

      // tH_ǉ
      if(level == 2){

        // ÕtH_
        currentFolder = currentFolder->parent;

        f = newEntry();
        strncpy(f->caption, line, CAPTION_MAX);
        f->type = FOLDER;
        addEntry(currentFolder, f);
        currentFolder = f;
      }

      // t@Cǉ
      else if(level == 3){

        // uށvtH_t@CT
        while((f = searchEntry(currentFolder->parent->child, line)) != NULL){
          moveEntry(currentFolder, f);
        }
      }
    }

    // ̍s
    line = pshellStrtok(NULL, "\r\n");
  }
}
