#include <piece.h>
#include <string.h>
#include "pshell.h"

#define MENU_MAX 8	// j[ڂ̍ő吔

// j[`p\
typedef struct _MENU MENU;

struct _MENU{
  char *label[MENU_MAX];		// eږ
  void (*function[MENU_MAX])(void);	// eڂŎs֐
  void (*returnFunction)(void);		// LZ̖߂
};

////////////////////////////////////////////////////////////////////////////////

// j[
static void menu(const MENU m){
  static int cursorPosition = 0;
  int i, w, width, items, cursorPositionOld;

  // j[̃TCY̐ݒ
  i = 0;
  width = 0;
  do{
    w = strlen(m.label[i]);

    if(w > width){
      width = w;
    }

    i++;
  }while((i < MENU_MAX) && (w > 0));
  items = i - 1;

  cursorPositionOld = cursorPosition;

  // J[\ړ
  if(pad & TRG_UP){
    cursorPosition--;
  }
  else if(pad & TRG_DN){
    cursorPosition++;
  }

  // ㉺Ń[v
  if(cursorPosition < 0){
    cursorPosition = items - 1;
  }
  else if(cursorPosition > items - 1){
    cursorPosition = 0;
  }

  // ωƂ̂݉ʂXV
  if(cursorPosition != cursorPositionOld){
    draw = TRUE;
  }

  if(draw){

    // g\
    pceLCDPaint(3, 63 - 2.5 * width, 43 - 5 * items, 5 * width + 2, 10 * items + 2);
    pceLCDPaint(0, 64 - 2.5 * width, 44 - 5 * items, 5 * width    , 10 * items    );

    for(i = 0; i < items; i++){

      // J[\ʒuȂ甽]\
      if(i == cursorPosition){
        pceFontSetTxColor(0);
        pceFontSetBkColor(3);
      }

      pceFontSetPos(64 - 2.5 * strlen(m.label[i]), 44 - 5 * items + 10 * i);
      pceFontPrintf("%s", m.label[i]);

      // ]\ɖ߂
      if(i == cursorPosition){
        pceFontSetTxColor(3);
        pceFontSetBkColor(0);
      }
    }
  }

  // `{^Ŏs
  if(pad & TRG_A){
    nextFunction = m.function[cursorPosition];
    drawNext = TRUE;

    cursorPosition = 0;
  }

  // a{^ŃLZ
  else if(pad & TRG_B){
    nextFunction = m.returnFunction;
    drawNext = TRUE;

    cursorPosition = 0;
  }
}

////////////////////////////////////////////////////////////////////////////////

// t@Cj[
void fileMenu(void){
  MENU m = {
    {"", "O̕ύX", "Rs[", "폜", "", "", "", ""},
    {fileInfomation, prepareFileRename, prepareFileCopy, deleteFileDialog,
     NULL, NULL, NULL, NULL},
    viewFolderTree
  };

  menu(m);
}

// tH_j[
void folderMenu(void){
  MENU m = {
    {"", "폜", "", "", "", "", "", ""},
    {folderInfomation, deleteFolderDialog, NULL, NULL, NULL, NULL, NULL, NULL},
    viewFolderTree
  };

  menu(m);
}

// VXej[
void systemMenu(void){
  MENU m = {
    {"ݒ", "ʒ", "RgXg", "", "", "", "", ""},
    {getTime, setVolume, setContrast, NULL, NULL, NULL, NULL, NULL},
    viewFolderTree
  };

  menu(m);
}
