#include <piece.h>
#include <string.h>
#include "pshell.h"

#define DIALOG_MAX 8	// _CAO̍ős
#define LABEL_MAX 26	// _CAO̍ő啶i'\0'܂ށj

// _CAO`p\
typedef struct _DIALOG DIALOG;

struct _DIALOG{
  char *label[DIALOG_MAX];		// bZ[W
  void (*functionA)(void);		// `{^Ŏs֐
  void (*functionB)(void);		// a{^Ŏs֐
};

////////////////////////////////////////////////////////////////////////////////

// _CAO
static void dialog(const DIALOG d){
  int i, w, width, height;

  if(draw){

    // _CAÕTCY̐ݒ
    i = 0;
    width = 0;
    do{
      w = strlen(d.label[i]);

      if(w > width){
        width = w;
      }

      i++;
    }while((i < DIALOG_MAX) && (w > 0));
    height = i - 1;

    // g\
    pceLCDPaint(3, 63 - 2.5 * width, 43 - 5 * height, 5 * width + 2, 10 * height + 2);
    pceLCDPaint(0, 64 - 2.5 * width, 44 - 5 * height, 5 * width    , 10 * height    );

    for(i = 0; i < height; i++){
      pceFontSetPos(64 - 2.5 * strlen(d.label[i]), 44 - 5 * height + 10 * i);
      pceFontPrintf("%s", d.label[i]);
    }
  }

  // `{^ꂽ
  if(pad & TRG_A){
    nextFunction = d.functionA;
    drawNext = TRUE;
  }

  // a{^ꂽ
  else if(pad & TRG_B){
    nextFunction = d.functionB;
    drawNext = TRUE;
  }
}

////////////////////////////////////////////////////////////////////////////////

// eʕs_CAO
void flashShortageDialog(void){
  DIALOG d;
  char s[LABEL_MAX];

  pcesprintf(s, "Rs[ɂ%dZN^", currentFile->sectors);

  d.label[0] = "̃t@C";
  d.label[1] = s;
  d.label[2] = "󂫗eʂKvłB";
  d.label[3] = "";
  d.functionA = viewFolderTree;
  d.functionB = viewFolderTree;

  dialog(d);
}

// startup.pex㏑֎~_CAO
void startupPexDialog(void){
  DIALOG d = {
    {
      "startup.pex",
      "㏑ł܂B",
      "",
      "",
      "",
      "",
      "",
      ""
    },
    viewFolderTree,
    viewFolderTree
  };

  dialog(d);
}

// t@Cd_CAO
void fileNameOverlapDialog(void){
  DIALOG d;

  // t@CɂăbZ[Wς
  if(copyMode){
    d.label[0] = "Rs[ƃRs[";
  }
  else{
    d.label[0] = "ύXOƕύX";
  }

  d.label[1] = "t@CłB";
  d.label[2] = "";
  d.functionA = viewFolderTree;
  d.functionB = viewFolderTree;

  dialog(d);
}

// t@Cs_CAO
void invalidFileNameDialog(void){
  DIALOG d;
  char s[LABEL_MAX];

  pcesprintf(s, "%s", newFileName);

  d.label[0] = s;
  d.label[1] = "sȃt@CłB";
  d.label[2] = "";
  d.functionA = viewFolderTree;
  d.functionB = viewFolderTree;

  dialog(d);
}

// t@C㏑mF_CAO
void overWriteFileDialog(void){
  DIALOG d;
  char s[LABEL_MAX];

  pcesprintf(s, "%s͊", newFileName);

  d.label[0] = s;
  d.label[1] = "݂܂B㏑";
  d.label[2] = "낵łH";
  d.label[3] = "A:YES / B:NO";
  d.label[4] = "";

  // t@CɂĎs֐ς
  if(copyMode){
    d.functionA = copyFile;
  }
  else{
    d.functionA = renameFile;
  }

  d.functionB = viewFolderTree;

  dialog(d);
}

// t@C폜mF_CAO
void deleteFileDialog(void){
  DIALOG d = {
    {
      "̃t@C폜",
      "낵łH",
      "A:YES / B:NO",
      "",
      "",
      "",
      "",
      ""
    },
    deleteFile,
    viewFolderTree
  };

  dialog(d);
}

// tH_폜mF_CAO
void deleteFolderDialog(void){
  DIALOG d = {
    {
      "̃tH_",
      "t@CSč폜",
      "낵łH",
      "A:YES / B:NO",
      "",
      "",
      "",
      ""
    },
    deleteFile,
    viewFolderTree
  };

  dialog(d);
}
