#include <piece.h>
#include <string.h>
#include "pshell.h"

// tbV̋󂫃ZN^𐔂
static void CountFreeSectors(void){
  const SYSTEMINFO *systemInfomation;
  pffsMASTERBLOCK *masterBlock;
  unsigned long top, end;
  int i, sectors;

  // VXe擾
  systemInfomation = pceSystemGetInfo();

  // ǗubN擾
  masterBlock = (pffsMASTERBLOCK *)systemInfomation->pffs_top;

  top = (unsigned long)systemInfomation->pffs_top;
  end = (unsigned long)systemInfomation->pffs_end;
  sectors = (end - top) / SECTOR_SIZE;

  // 󂫃ZN^𐔂
  freeSectors = 0;
  for(i = 0; i < sectors; i++){
    if(masterBlock->fat[i].chain == FAT_FREE){
      freeSectors++;
    }
  }
}

// ̃tH_폜
static void deleteEmptyFolder(FILE_ENTRY *folder){
  FILE_ENTRY *f, *fNext;

  // tH_łȂΉȂ
  if(folder->type == FOLDER){
    f = folder->child;

    while(f != NULL){
      fNext = f->next;
      deleteEmptyFolder(f);
      f = fNext;
    }

    // [g͍폜Ȃ
    if((folder->child == NULL) && (folder != root)){
      deleteEntry(folder);
    }
  }
}

////////////////////////////////////////////////////////////////////////////////

// tH_c[̏
void initialize(void){

  // t@CGgSč폜
  deleteEntry(root);

  // tbV̋󂫃ZN^𐔂
  CountFreeSectors();

  program = newEntry();
  strcpy(program->caption, "vO");
  program->type = FOLDER;
  addEntry(root, program);

  uncategorizedProgram = newEntry();
  strcpy(uncategorizedProgram->caption, "");
  uncategorizedProgram->type = FOLDER;
  addEntry(program, uncategorizedProgram);

  data = newEntry();
  strcpy(data->caption, "f[^");
  data->type = FOLDER;
  addEntry(root, data);

  uncategorizedData = newEntry();
  strcpy(uncategorizedData->caption, "");
  uncategorizedData->type = FOLDER;
  addEntry(data, uncategorizedData);

  // t@C̎擾
  getFiles();

  // RtBOt@C̓ǂݍ
  readConfigFile();

  // ̃tH_폜
  deleteEmptyFolder(root);

  if(root->child != NULL){
    nextFunction = viewFolderTree;
  }

  // startup.pexȊÕt@CȂ΃^Cg\
  else{
    nextFunction = printTitle;
  }

  // J[\ʒu
  currentFile = root->child;
  currentLevel = 1;
  screenPosition = 0;

  drawNext = TRUE;
}
